



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>LeetCode 笔记总结</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">LeetCode 笔记总结</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-30 00:29:45 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h1>前言</h1>
<p>之前把一些LeetCode里面的题目的思路写在了本子上，现在把这些全都放到博客上，以后翻阅比较方便。</p>
<h1>题目</h1>
<h2>99.Recover Binary Search Tree</h2>
<h3>题意</h3>
<p>Two elements of a binary search tree (BST) are swapped by mistake.</p>
<p>Recover the tree without changing its structure.</p>
<p>恢复两个因错误而导致的左右子树。</p>
<h3>思路</h3>
<p>通常我们的做法是，根据BST的特质，可以用中序遍历来检查数值的变化，找到错误的左右子树。</p>
<p>中序遍历分为递归和非递归，其中非递归版本除了熟知的栈＋迭代的版本；</p>
<p>其实非递归还有另外一个算法－Morris Traversal。这个算法的好处在于，1⃣️O(1)的空间，常数空间；2⃣️二叉树的形状不会被更改（中间允许改变形状）。<strong>其实就是增加纪录了叶子结点的前驱结点和后继结点（这样可以很便利的访问到某个叶子结点的上一个结点和下一个结点），用时间换取空间。</strong>比如，这样做就可以从左子树的最右结点到达跟节点。</p>
<h3>实现</h3>
<pre class="prettyprint linenums"><code>**<br />
 *  使用了Morris traversal 算法， 花费常量内存空间<br />
 *<br />
 *  @param root &lt;#root description#&gt;<br />
 */<br />
void recoverTree3(TreeNode* root) {<br />
    TreeNode *first = NULL;<br />
    TreeNode *second = NULL;<br />
    TreeNode *pred = NULL;  // 前驱结点<br />
    TreeNode *prev = NULL;  // 用来记录之前结点，访问右子树<br />
    TreeNode *curr = root;  // 当前结点

    while (curr != NULL) {<br />
        // 和前面做法一样<br />
        if (prev != NULL &amp;&amp; curr-&gt;val &lt;= prev-&gt;val) {<br />
            if (first == NULL) first = prev;<br />
            second = curr;<br />
        }

        if (curr-&gt;left != NULL) {<br />
            pred = curr-&gt;left;

            // 不断遍历，找到左子树的最右结点<br />
            while (pred-&gt;right != NULL &amp;&amp; pred-&gt;right != curr) {<br />
                pred = pred-&gt;right;<br />
            }

            // 如果前驱结点的右孩子为当前结点，将它的右孩子重新设置为空（恢复树的形状）<br />
            // 当前结点更新为当前结点的右孩子<br />
            if (pred-&gt;right == curr) {<br />
                pred-&gt;right = NULL;<br />
                prev = curr;<br />
                curr = curr-&gt;right;<br />
            }<br />
            else {<br />
                // 如果前驱结点的右孩子为空，将它的右孩子设置为当前结点。<br />
                // 当前结点更新为当前结点的左孩子<br />
                pred-&gt;right = curr;<br />
                curr = curr-&gt;left;<br />
            }<br />
        }<br />
        else {<br />
            //访问右子树<br />
            prev = curr;<br />
            curr = curr-&gt;right;<br />
        }<br />
    }

    int temp = first-&gt;val;<br />
    first-&gt;val = second-&gt;val;<br />
    second-&gt;val = temp;<br />
}

</code></pre>
<p>具体可参考 <a href="http://www.cnblogs.com/AnnieKim/archive/2013/06/15/MorrisTraversal.html" rel="external nofollow noreferrer">博客</a></p>
<h2>105. Construct Binary Tree from Preorder and Inorder Traversal</h2>
<h3>题意</h3>
<p>根据给定的前序和中序遍历构造BST</p>
<h3>思路</h3>
<ul><li>前序：中左右</li>
<li>中序：左中右</li>
<li>后序：左右中</li></ul>
<p>利用中序找到中间节点（需要操作的点），前序则用来确定左右子结点。同样的，因为是DFS，所以同样可以用递归和非递归实现。</p>
<h2>106. Construct Binary Tree from Inorder and Postorder Traversal</h2>
<p>同上,需要注意边界问题。</p>
<h2>108. Convert Sorted Array to Binary Search Tree</h2>
<h3>思路</h3>
<p>根据中序遍历的特点，递归或者取得数组的中间点作为父结点。</p>
<h2>109. Convert Sorted List to Binary Search Tree</h2>
<h3>思路</h3>
<p>和108题目类似。注意这里是链表。</p>
<h2>110. Flatten Binary Tree to Linked List</h2>
<h3>思路</h3>
<p>注意将左子树的最右结点连接到跟节点上。</p>
<h2>116. Populating Next Right Pointers in Each Node</h2>
<h3>题意</h3>
<p>为每个结点加上兄弟节点。</p>
<h3>思路</h3>
<ul><li>迭代：先找到树的每一层的最左边的结点，再往右进行迭代，直到右边不存在结点时则设置为null。</li>
<li>递归：专注于处理兄弟结点的处理，因为递归从上至下访问到每一个结点。</li></ul>
<h3>实现</h3>
<pre class="prettyprint linenums"><code>/**<br />
 *  两个迭代<br />
 *  一个是移动当前结点，一个是设置右子结点<br />
 *<br />
 *  @param root &lt;#root description#&gt;<br />
 */<br />
void connect(TreeLinkNode *root) {<br />
    if (root == NULL)<br />
        return ;<br />
    TreeLinkNode * pre = root;<br />
    TreeLinkNode * cur = NULL;

    // 访问每一层的最左子结点，也就是每一层的第一个子结点<br />
    while (pre-&gt;left) {<br />
        cur = pre;<br />
        while (cur) {<br />
            cur-&gt;left-&gt;next = cur-&gt;right;<br />
            // 不同子树之间的连接<br />
            if (cur-&gt;next)<br />
                cur-&gt;right-&gt;next = cur-&gt;next-&gt;left;<br />
            cur = cur-&gt;next;<br />
        }<br />
        pre = pre-&gt;left;<br />
    }<br />
}

</code></pre>
<h2>117. Populating Next Right Pointers in Each Node II</h2>
<h3>题意</h3>
<p>和前面的题目不同的点在于，这里的二叉树不再是平衡二叉树，而是任何的二叉树。</p>
<h3>思路</h3>
<p>无法保证右边结点是否存在，不能是遍历这一层的同时连接着一层，而是遍历这一层连接下一层。</p>
<h3>实现</h3>
<pre class="prettyprint linenums"><code>/**<br />
 *  start作为父亲结点，通过end结点移动，如果start有子结点，则让end连接起来<br />
 *  levelEnd作为每一层的最右结点，也就是结束的结点，将其next设置为空<br />
 *<br />
 *  @param root &lt;#root description#&gt;<br />
 */<br />
void connect(TreeLinkNode *root) {<br />
    if (root == NULL) return ;<br />
    TreeLinkNode * start = root;<br />
    TreeLinkNode * end = root;<br />
    TreeLinkNode * levelEnd = root;

    while (start != NULL) {<br />
        // 指向左子节点<br />
        if (start-&gt;left != NULL) {<br />
            end-&gt;next = start-&gt;left;<br />
            end = end-&gt;next;<br />
        }

        // 指向右子节点<br />
        if (start-&gt;right != NULL) {<br />
            end-&gt;next = start-&gt;right;<br />
            end = end-&gt;next;<br />
        }

        // 判断是否到右边最后的结点，否则一直向右移动<br />
        if (start == levelEnd) {<br />
            start = start-&gt;next;<br />
            levelEnd-&gt;next = NULL;<br />
            levelEnd = end;<br />
        }<br />
        else {<br />
            start = start-&gt;next;<br />
        }<br />
    }<br />
}<br />
</code></pre>
<p>下面3个结点：</p>
<ul><li>start 作为移动的点</li>
<li>end 根据start是否有子结点，并将其每个子结点连接起来。</li>
<li>levelEnd 纪录每一层的最后一个结点，用来和start进行判断是否已经到该层的最后一个结点，否则start移动，用end去更新levelEnd。</li></ul>
<h2>133. Clone Graph</h2>
<h3>题意</h3>
<p>克隆无向图</p>
<h3>思路</h3>
<p>每个结点都维护着自己的邻居结点。因为是无向图，需要在迭代或者递归的时候避免重复访问无向图的结点，所以所有方法都需要维护着一个全局的unordered_map的哈希表，纪录访问过的结点。</p>
<ul><li>DFS迭代</li>
<li>DFS递归</li>
<li>BFS迭代</li>
<li>BFS递归</li></ul>
<h2>207. Course Schedule</h2>
<h3>题意</h3>
<p>题意给定了一系列的课程，而且要求上完一门课程才可以上下一门课程。判断是否能够上完题目给定的所有课程。</p>
<p><a href="https://leetcode.com/problems/course-schedule/?tab=Description" rel="external nofollow noreferrer">题目</a></p>
<h3>思路</h3>
<p>这可以理解成一副有向图，对于这种要求有向图进行排序，每个顶点只能输出一次，不允许出现出现环，可以使用拓扑排序这种图论算法。</p>
<p>算法同样可以通过</p>
<ul><li>BFS实现</li>
<li>DFS实现</li></ul>
<p>注意图的三种表达方式</p>
<ul><li>边表示法</li>
<li>邻接表法</li>
<li>邻接矩阵法</li></ul>
<ol><li>初始化邻接表（根据要求），并且填满邻接表；</li>
<li>计算每个结点的前驱结点的个数；</li>
<li>每次找到一个没有前驱结点，也就是入度为0；</li>
<li>把它指向其他结点的边去掉，减去出度的个数；</li>
<li>直到所有结点都已经找到，或者没有符合条件的结点。</li></ol>
<h3>实现</h3>
<pre class="prettyprint linenums"><code>/**<br />
 *  判断有向图是否有环<br />
 *  通过DFS找环<br />
 *<br />
 *  @param matrix  &lt;#matrix description#&gt;<br />
 *  @param visited &lt;#visited description#&gt;<br />
 *  @param idx     &lt;#idx description#&gt;<br />
 *  @param flag    &lt;#flag description#&gt;<br />
 *<br />
 *  @return &lt;#return value description#&gt;<br />
 */<br />
bool DFS(vector&lt;unordered_set&lt;int&gt;&gt; &amp;matrix, unordered_set&lt;int&gt; &amp;visited, int idx, vector&lt;bool&gt; &amp;flag) {<br />
    flag[idx] = true; // 标记该结点访问过<br />
    visited.insert(idx);

    // 找出该结点的所有邻居结点，如果存在访问过的结点或者递归，则返回true<br />
    for (auto it = matrix[idx].begin(); it != matrix[idx].end(); ++it) {<br />
        if (visited.find(*it) != visited.end() || DFS(matrix, visited, *it, flag)) {<br />
            return true;<br />
        }<br />
    }

    visited.erase(idx);<br />
    return false;<br />
}<br />
bool canFinish(int numCourses, vector&lt;pair&lt;int, int&gt;&gt;&amp; prerequisites) {<br />
    vector&lt;unordered_set&lt;int&gt;&gt; matrix(numCourses);<br />
    // 要想完成第一门课程，则先完成第二门课程(后面的是先要完成的课程)<br />
    // 构建图<br />
    for (int i = 0; i &lt; prerequisites.size(); ++i) {<br />
        matrix[prerequisites[i].second].insert(prerequisites[i].first);<br />
    }

    unordered_set&lt;int&gt; visited; // 记录一个递归访问过的结点<br />
    vector&lt;bool&gt; flag(numCourses, false); // 记录是否访问过结点

    /**<br />
     *  遍历所有课程，也就是结点<br />
     *  判断是否标记过结点，如果没有则进行DFS判断是否存在回路，存在回路则返回false<br />
     */<br />
    for (int i = 0; i &lt; numCourses; ++i) {<br />
        if (!flag[i])<br />
            // 如果递归中存在访问过的结点，则该拓扑排序是不存在的，也就无法完成课程<br />
            if (DFS(matrix, visited, i, flag))<br />
                return false;<br />
    }<br />
    return true;<br />
}

/**<br />
 *  BFS的拓扑排序实现<br />
 *<br />
 *  @param numCourses      &lt;#numCourses description#&gt;<br />
 *  @param vector&lt;pair&lt;int &lt;#vector&lt;pair&lt;int description#&gt;<br />
 *  @param prerequisites   &lt;#prerequisites description#&gt;<br />
 *<br />
 *  @return &lt;#return value description#&gt;<br />
 */<br />
bool canFinish2(int numCourses, vector&lt;pair&lt;int, int&gt;&gt;&amp; prerequisites) {<br />
    vector&lt;unordered_set&lt;int&gt;&gt; matrix(numCourses);<br />
    for (int i = 0; i &lt; prerequisites.size(); i++) {<br />
        matrix[prerequisites[i].second].insert(prerequisites[i].first);<br />
    }

    vector&lt;int&gt; d(numCourses, 0);<br />
    // 计算每个结点的入度<br />
    // 增加每个结点的邻居结点的个数<br />
    for (int i = 0; i &lt; numCourses; ++i)<br />
        for (auto it = matrix[i].begin(); it != matrix[i].end(); ++it)<br />
            ++d[*it];;

    // 如果找不到，则返回不能完成<br />
    for (int i = 0, j; i &lt; numCourses; ++i) {<br />
        for (j = 0; j &lt; numCourses &amp;&amp; d[j] != 0; ++j);<br />
        if (j == numCourses)<br />
            return false;

        d[j] = -1;<br />
        for (auto it = matrix[j].begin(); it != matrix[j].end(); ++it)<br />
            --d[*it];<br />
    }<br />
    return true;<br />
}

</code></pre>
<h2>210. Course Schedule II</h2>
<h3>题目</h3>
<p>在前面的基础上，纪录下上完所有课程的顺序。</p>
<p><a href="https://leetcode.com/problems/course-schedule-ii/?tab=Description" rel="external nofollow noreferrer">题目</a></p>
<h3>思路</h3>
<p>加个数组进行纪录路径。算法和之前一样。</p>
<h3>实现</h3>
<pre class="prettyprint linenums"><code>/**<br />
 *  拓扑排序的DFS实现，思想和1类似<br />
 *<br />
 *  @param graph    &lt;#graph description#&gt;<br />
 *  @param node     &lt;#node description#&gt;<br />
 *  @param onpath   &lt;#onpath description#&gt;<br />
 *  @param visited  &lt;#visited description#&gt;<br />
 *  @param toposort &lt;#toposort description#&gt;<br />
 *<br />
 *  @return &lt;#return value description#&gt;<br />
 */<br />
bool DFS(vector&lt;unordered_set&lt;int&gt;&gt;&amp; graph, int node, vector&lt;bool&gt;&amp; onpath, vector&lt;bool&gt;&amp; visited, vector&lt;int&gt;&amp; toposort) {<br />
    // 标记该结点被访问过<br />
    onpath[node] = visited[node] = true;

    for (int neigh : graph[node]) {<br />
        if (onpath[neigh] || DFS(graph, node, onpath, visited, toposort))<br />
            return true;<br />
    }<br />
    toposort.push_back(node);<br />
    return onpath[node] = false;<br />
}<br />
vector&lt;int&gt; findOrder(int numCourses, vector&lt;pair&lt;int, int&gt;&gt;&amp; prerequisites) {<br />
    vector&lt;unordered_set&lt;int&gt;&gt; graph(numCourses);<br />
    // 构建临接表<br />
    for (auto pre : prerequisites)<br />
        graph[pre.second].insert(pre.first);

    vector&lt;bool&gt; onpath(numCourses, false), visited(numCourses, false);<br />
    vector&lt;int&gt; result;

    for (int i = 0; i &lt; numCourses; i++) {<br />
        if (!visited[i] &amp;&amp; DFS(graph, i, onpath, visited, result))<br />
            return {};<br />
    }<br />
    reverse(result.begin(), result.end());<br />
    return result;<br />
}

/**<br />
 *  拓扑排序的BFS实现，思想和1类似<br />
 *<br />
 *  @param graph &lt;#graph description#&gt;<br />
 *<br />
 *  @return &lt;#return value description#&gt;<br />
 */<br />
vector&lt;int&gt; compute_indegree(vector&lt;unordered_set&lt;int&gt;&gt; &amp;graph) {<br />
    vector&lt;int&gt; degress(graph.size(), 0);<br />
    for (auto neighbors : graph)<br />
        for (int neigh : neighbors)<br />
            degress[neigh] ++;<br />
    return degress;<br />
}

vector&lt;int&gt; findOrder2(int numCourses, vector&lt;pair&lt;int, int&gt;&gt;&amp; prerequisites) {<br />
    vector&lt;unordered_set&lt;int&gt;&gt; graph(numCourses);<br />
    // 构建临接表<br />
    for (auto pre : prerequisites)<br />
        graph[pre.second].insert(pre.first);

    vector&lt;int&gt; degress = compute_indegree(graph);<br />
    queue&lt;int&gt; zeros;<br />
    vector&lt;int&gt; result;<br />
    for (int i = 0; i &lt; numCourses; i++) {<br />
        if (!degress[i]) zeros.push(i);<br />
    }

    for (int i = 0; i &lt; numCourses; i++) {<br />
        if (zeros.empty()) return {};<br />
        int zero = zeros.front();<br />
        zeros.pop();

        result.push_back(zero);<br />
        for (int neigh : graph[zero]) {<br />
            if (!--degress[neigh])<br />
                zeros.push(neigh);<br />
        }<br />
    }

    return result;<br />
}

</code></pre>
<h2>257. Binary Tree Paths</h2>
<h3>题目</h3>
<p><a href="https://leetcode.com/problems/binary-tree-paths/?tab=Description" rel="external nofollow noreferrer">题目</a></p>
<p>返回从根节点到叶结点的所有路径。</p>
<h3>思路</h3>
<ul><li>递归：更新路径字符串</li>
<li>迭代＋栈：使用了两个栈，一个用来存储当前结点，一个用来存储到达当前结点的路径字符串。</li></ul>
<h3>实现</h3>
<pre class="prettyprint linenums"><code>/**<br />
 *  递归将更新字符串，到达叶结点时加入到数组中<br />
 *<br />
 *  @param result &lt;#result description#&gt;<br />
 *  @param root   &lt;#root description#&gt;<br />
 *  @param t      &lt;#t description#&gt;<br />
 */<br />
void binaryTreePaths(vector&lt;string&gt;&amp; result, TreeNode* root, string t) {<br />
    if (!root-&gt;left &amp;&amp; !root-&gt;right) {<br />
        result.push_back(t);<br />
        return ;<br />
    }

    if (root-&gt;left) binaryTreePaths(result, root-&gt;left, t + &quot;-&gt;&quot; + to_string(root-&gt;left-&gt;val));<br />
    if (root-&gt;right) binaryTreePaths(result, root-&gt;right, t + &quot;-&gt;&quot; + to_string(root-&gt;right-&gt;val));

}<br />
vector&lt;string&gt; binaryTreePaths(TreeNode* root) {<br />
    vector&lt;string&gt; result;<br />
    if (!root) return result;

    binaryTreePaths(result, root, to_string(root-&gt;val));<br />
    return result;<br />
}

/**<br />
 *  迭代＋栈实现，用了两个栈，分别存储结点以及到达该结点的路径<br />
 *<br />
 *  @param root &lt;#root description#&gt;<br />
 *<br />
 *  @return &lt;#return value description#&gt;<br />
 */<br />
vector&lt;string&gt; binaryTreePaths2(TreeNode* root) {<br />
    vector&lt;string&gt; result;<br />
    if (root == NULL) return result;

    stack&lt;TreeNode *&gt; t_stack;<br />
    stack&lt;string&gt; s_stack;<br />
    t_stack.push(root);<br />
    s_stack.push(to_string(root-&gt;val));

    while (!t_stack.empty()) {<br />
        TreeNode * curNode = t_stack.top();<br />
        t_stack.pop();

        string curPath = s_stack.top();<br />
        s_stack.pop();

        if (!curNode-&gt;left &amp;&amp; !curNode-&gt;right) {<br />
            result.push_back(curPath);<br />
            continue;<br />
        }

        if (curNode-&gt;left) {<br />
            t_stack.push(curNode-&gt;left);<br />
            s_stack.push(curPath + &quot;-&gt;&quot; + to_string(curNode-&gt;left-&gt;val));<br />
        }

        if (curNode-&gt;right) {<br />
            t_stack.push(curNode-&gt;right);<br />
            s_stack.push(curPath + &quot;-&gt;&quot; + to_string(curNode-&gt;right-&gt;val));<br />
        }<br />
    }

    return result;<br />
}

</code></pre>
<h2>其他</h2>
<p>set和multiset都是集合类，差别在于set中不允许有重复元素，multiset中允许有重复元素，内部都以平衡二叉树实现。</p>
<ol><li>对于树的前序遍历（根左右），有效代码（处理函数）写在递归左子树之后，递归右子树之钱，也就是中间；</li>
<li>对于树的中序遍历（左根右），则写在递归左右子树之前；</li>
<li>对于树的后序遍历（左右根），则写在递归左右子树之后；</li></ol>
<h2>301. Remove Invalid Parentheses</h2>
<h3>题目</h3>
<p>移除最小数量的无效括号，使得输入字符串有效</p>
<h3>思路</h3>
<ul><li>DFS＋剪枝</li>
<li>BFS</li>
<li>BFS＋剪枝</li></ul>
<h3>实现</h3>
<pre class="prettyprint linenums"><code>class Solution {<br />
public:<br />
    /**<br />
     *  DFS＋剪枝<br />
     *<br />
     *  @param pair         多出来的遇见括号的个数<br />
     *  @param index        记录字符串s的当前位置<br />
     *  @param remove_left  左括号需要删除的个数<br />
     *  @param remove_right 右括号需要删除的个数<br />
     *  @param s            原始字符串<br />
     *  @param solution     生成字符串<br />
     *  @param result       存储所有的字符串结果<br />
     */<br />
    void helper(int pair, int index, int remove_left, int remove_right, const string&amp; s, string solution, unordered_set&lt;string&gt; &amp;result) {<br />
        if (index == s.size()) {<br />
            if (pair == 0 &amp;&amp; remove_left == 0 &amp;&amp; remove_right == 0)<br />
                result.insert(solution);<br />
            return ;<br />
        }

        if (s[index] == '(') {<br />
            // 删除左边括号<br />
            if (remove_left &gt; 0) helper(pair, index + 1, remove_left - 1, remove_right, s, solution, result);<br />
            // 回溯<br />
            helper(pair + 1, index + 1, remove_left, remove_right, s, solution + s[index], result);<br />
        }<br />
        else if (s[index] == ')') {<br />
            // 删除右边括号<br />
            if (remove_right &gt; 0) helper(pair, index + 1, remove_left, remove_right - 1, s, solution, result);<br />
            // 回溯<br />
            if (pair &gt; 0) helper(pair - 1, index + 1, remove_left, remove_right, s, solution + s[index], result);<br />
        }<br />
        else {<br />
            helper(pair, index + 1, remove_left, remove_right, s, solution + s[index], result);<br />
        }<br />
    }<br />
    vector&lt;string&gt; removeInvalidParentheses(string s) {<br />
        int remove_left = 0, remove_right = 0;<br />
        unordered_set&lt;string&gt; result; // 处理重复

        // 计算左右两边需要删除括号的个数<br />
        for (int i = 0; i &lt; s.size(); ++i) {<br />
            if (s[i] == '(')<br />
                remove_left++;<br />
            else if (s[i] == ')') {<br />
                if (remove_left &gt; 0) remove_left--;<br />
                else remove_right++;<br />
            }<br />
        }

        helper(0, 0, remove_left, remove_right, s, &quot;&quot;, result);

        return vector&lt;string&gt;(result.begin(), result.end());<br />
    }

    bool check(string s) {<br />
        int count = 0;<br />
        for (int i = 0; i &lt; s.size(); i++) {<br />
            char tmp = s[i];<br />
            if (tmp == '(') count++;<br />
            if (tmp == ')') {<br />
                if (count == 0) return false;<br />
                count--;<br />
            }<br />
        }<br />
        return count == 0;<br />
    }

    /**<br />
     *  这个解法看似和上面解法类似，以为是DFS，但是其实是个BFS，思路和2是类似的，只不过用递归实现<br />
     *  删除子串的每个字符，然后进行递归<br />
     *<br />
     *<br />
     *  @param begin        记录原字符串的下标，为什么是BFS的原因<br />
     *  @param remove_left  需要删除左边括号的个数<br />
     *  @param remove_right 需要删除右边括号的个数<br />
     *  @param s            子串<br />
     *  @param result       结果<br />
     */<br />
    void helper2(int begin, int remove_left, int remove_right, string s, vector&lt;string&gt; &amp;result) {<br />
        // 如果左右已经没有要删除的括号，并且符合条件，则进行收敛<br />
        if (remove_left == 0 &amp;&amp; remove_right == 0) {<br />
            if (check(s)) {<br />
                result.push_back(s);<br />
                return;<br />
            }<br />
        }

        // begin是个重点，意味着从begin开始往后删，前面的字符串不再动<br />
        for (int i = begin; i &lt; s.size(); ++i) {<br />
            string temp = s;<br />
            if (remove_left &gt; 0 &amp;&amp; remove_right == 0 &amp;&amp; s[i] == '(') {<br />
                // 删除子串的每个字符，同时避免重复<br />
                if (begin == i || s[i] != s[i-1]) {<br />
                    temp.erase(i, 1);<br />
                    helper2(i, remove_left-1, remove_right, temp, result);<br />
                }<br />
            }<br />
            if (remove_right &gt; 0 &amp;&amp; s[i] == ')') {<br />
                if (begin == i || s[i] != s[i-1]) {<br />
                    temp.erase(i, 1);<br />
                    helper2(i, remove_left, remove_right-1, temp, result);<br />
                }<br />
            }<br />
        }

    }<br />
    vector&lt;string&gt; removeInvalidParentheses3(string s) {<br />
        int remove_left = 0, remove_right = 0;<br />
        vector&lt;string&gt; result; // 处理重复

        // 计算左右两边需要删除括号的个数<br />
        for (int i = 0; i &lt; s.size(); ++i) {<br />
            if (s[i] == '(')<br />
                remove_left++;<br />
            else if (s[i] == ')') {<br />
                if (remove_left &gt; 0) remove_left--;<br />
                else remove_right++;<br />
            }<br />
        }

        helper2(0, remove_left, remove_right, s, result);

        return result;<br />
    }

    /**<br />
     *  通过从输入字符串中移除每一个括号，生成新的字符串加入到队列中<br />
     *  如果从队列中取出的字符串是有效的，则加入到结果列表中<br />
     *  一旦发现有效的字符串，则不再向队列中补充新的字符串，其去掉的括号数一定是最小的<br />
     *  而此时，队列中存在的元素与队列头元素去掉的括号数的差值 &lt;= 1<br />
     *  并且，只有与队列头元素去掉括号数目相同的元素才有可能是候选答案<br />
     *<br />
     *  @param s &lt;#s description#&gt;<br />
     *<br />
     *  @return &lt;#return value description#&gt;<br />
     */<br />
    vector&lt;string&gt; removeInvalidParentheses2(string s) {<br />
        vector&lt;string&gt; result;<br />
        if (s == &quot;&quot;) {<br />
            result.push_back(s);<br />
            return result;<br />
        }

        unordered_set&lt;string&gt; visited; // 控制是否访问过字符串，因为要求不可重复<br />
        deque&lt;string&gt; queue;<br />
        queue.push_back(s);<br />
        visited.insert(s);

        bool found = false;<br />
        while (!queue.empty()) {<br />
            string temp = queue.front();<br />
            queue.pop_front();

            // 每次遍历代表着需要加进来去掉一个括号的子串，层数代表删除括号的次数<br />
            // 只要第一次符合情况了，说明该字符串已经是可去掉括号数目最小的字符串层<br />
            // 意味着该层不再需要加进来任何的子串了，<br />
            if (check(temp)) {<br />
                result.push_back(temp);<br />
                found = true;<br />
            }

            if (found) continue;<br />
            for (int i = 0; i &lt; temp.size(); ++i) {<br />
                if (temp[i] != '(' &amp;&amp; temp[i] != ')') continue;<br />
                // 删除括号，生成新的字符串<br />
                string str = temp.substr(0, i) + temp.substr(i+1);

                if (visited.find(str) == visited.end()) {<br />
                    queue.push_back(str);<br />
                    visited.insert(str);<br />
                }<br />
            }<br />
        }

        return result;<br />
    }

    bool test() {<br />
        string s = &quot;(a)b)c)d&quot;;<br />
        vector&lt;string&gt; result = removeInvalidParentheses3(s);<br />
        cout &lt;&lt; result.size() &lt;&lt; endl;<br />
        return true;<br />
    }<br />
};

</code></pre>
<p>这道题很好，抓在手里。</p>
<h2>337. House Robber III</h2>
<h3>题意</h3>
<p><a href="https://leetcode.com/problems/house-robber-iii/?tab=Description" rel="external nofollow noreferrer">题目</a></p>
<p>大致是盗贼在不惊动警察的情况下（同时偷相邻层的情况下最多可以偷到的金钱数目，不允许偷相连，比如父结点和子结点）</p>
<h3>思路</h3>
<ul><li>DFS：每次遍历返回两个值：分别表示偷窃或者不偷窃当前结点可以获得的最大收益，需要额外的空间维护；</li>
<li>DFS＋Memorization 记忆化搜索：计算子节点收益（当前结点不偷）和孙子结点收益加上当前结点收益（当前结点偷）</li></ul>
<h3>实现</h3>
<pre class="prettyprint linenums"><code>class Solution {<br />
public:

    /**<br />
     *  超时<br />
     *  此结点的最大值有两种情况，一种是该结点值加上不包含左子结点<br />
     *  和右子结点的返回值之和，另一种是左右子结点返回值之和不包含<br />
     *  当前结点值，取两者的较大值返回即可；<br />
     *<br />
     *  @param root &lt;#root description#&gt;<br />
     *<br />
     *  @return &lt;#return value description#&gt;<br />
     */<br />
    int rob(TreeNode* root) {<br />
        if (!root) {<br />
            return 0;<br />
        }<br />
        int val = 0;<br />
        if (root-&gt;left) {<br />
            val += rob(root-&gt;left-&gt;left) + rob(root-&gt;left-&gt;right);<br />
        }<br />
        if (root-&gt;right) {<br />
            val += rob(root-&gt;right-&gt;left) + rob(root-&gt;right-&gt;right);<br />
        }<br />
        return max(val + root-&gt;val, rob(root-&gt;left) + rob(root-&gt;right));<br />
    }

    /**<br />
     *  和上面做法相同，增加一个哈希表保存之前计算过的结点<br />
     *<br />
     *  @param root                   &lt;#root description#&gt;<br />
     *  @param unordered_map&lt;TreeNode &lt;#unordered_map&lt;TreeNode description#&gt;<br />
     *  @param map                    &lt;#map description#&gt;<br />
     *<br />
     *  @return &lt;#return value description#&gt;<br />
     */<br />
    int DFS(TreeNode * root, unordered_map&lt;TreeNode*, int&gt;&amp; map) {<br />
        if (!root)<br />
            return 0;<br />
        if (map.count(root))<br />
            return map[root];<br />
        int val = 0;<br />
        if (root-&gt;left) {<br />
            val += DFS(root-&gt;left-&gt;left, map) + DFS(root-&gt;left-&gt;right, map);<br />
        }<br />
        if (root-&gt;right) {<br />
            val += DFS(root-&gt;right-&gt;left, map) + DFS(root-&gt;right-&gt;right, map);<br />
        }<br />
        val = max(val + root-&gt;val, DFS(root-&gt;left, map) + DFS(root-&gt;right, map));<br />
        map[root] = val;<br />
        return val;<br />
    }<br />
    int rob2(TreeNode * root) {<br />
        unordered_map&lt;TreeNode*, int&gt; map;<br />
        return DFS(root, map);<br />
    }

    /**<br />
     *  DFS + DP<br />
     *  用的是大小为2的数组，分别保存不包含当前结点值的最大值和当前值的最大值<br />
     *<br />
     *  @param root &lt;#root description#&gt;<br />
     *<br />
     *  @return &lt;#return value description#&gt;<br />
     */<br />
    vector&lt;int&gt; robSub(TreeNode* root) {<br />
        if (root == NULL) {<br />
            return vector&lt;int&gt;(2, 0);<br />
        }

        vector&lt;int&gt; left = robSub(root-&gt;left);<br />
        vector&lt;int&gt; right = robSub(root-&gt;right);

        vector&lt;int&gt; result(2, 0);<br />
        // 当前结点不偷的情况下，取左右子结点偷或不偷的最大收益<br />
        result[0] = max(left[0], left[1]) + max(right[0], right[1]);<br />
        // 当前结点偷的情况下，取左右子结点不偷的情况的收益<br />
        result[1] = root-&gt;val + left[0] + right[0];

        return result;<br />
    }<br />
    int rob3(TreeNode* root) {<br />
        vector&lt;int&gt; result  = robSub(root);<br />
        // 取出的是跟结点里面偷和不偷的最大收益<br />
        return max(result[0], result[1]);<br />
    }

    /**<br />
     *  DFS + 记忆化<br />
     *<br />
     *  @param root &lt;#root description#&gt;<br />
     *  @param l    &lt;#l description#&gt;<br />
     *  @param r    &lt;#r description#&gt;<br />
     *<br />
     *  @return &lt;#return value description#&gt;<br />
     */<br />
    int tryRob(TreeNode* root, int&amp; l, int&amp; r) {<br />
        if (!root)<br />
            return 0;<br />
        int ll = 0, lr = 0, rl = 0, rr = 0;<br />
        l = tryRob(root-&gt;left, l, r);<br />
        r = tryRob(root-&gt;right, l, r);

        // 前者为偷当前结点，所以加上孙结点的收益<br />
        // 后者为不偷当前结点，所以加上子结点的收益<br />
        return max(root-&gt;val + ll + lr + rl + rr, l + r);<br />
    }<br />
    int rob4(TreeNode* root) {<br />
        int l, r;<br />
        return tryRob(root, l, r);<br />
    }<br />
};

</code></pre>
<p>需要另外学习记忆化搜索的知识。</p>
<h2>329. Longest Increasing Path in a Matrix</h2>
<h3>题意</h3>
<p>二维数组中选出一条递增的路径，返回路径的最大个数。</p>
<h3>思路</h3>
<ul><li>DFS＋Memorization：枚举起点，从每一个单元格出发，递归寻找最长递增路径；</li>
<li>排序＋DP</li></ul>
<p>两种方法都需要借助DP数组（存储从单元格x,y出发的最长递增序列长度）来进行辅助。</p>
<h3>实现</h3>
<pre class="prettyprint linenums"><code>class Solution {<br />
public:<br />
    /**<br />
     *  DFS + DP<br />
     *<br />
     *  @param matrix &lt;#matrix description#&gt;<br />
     *  @param states &lt;#states description#&gt;<br />
     *  @param i      &lt;#i description#&gt;<br />
     *  @param j      &lt;#j description#&gt;<br />
     *  @param m      &lt;#m description#&gt;<br />
     *  @param n      &lt;#n description#&gt;<br />
     *<br />
     *  @return &lt;#return value description#&gt;<br />
     */<br />
    int longestPath(vector&lt;vector&lt;int&gt;&gt;&amp; matrix, vector&lt;vector&lt;int&gt;&gt;&amp; states, int i, int j, int m, int n) {<br />
        if (states[i][j] &gt; 0)<br />
            return states[i][j];

        int maxd = 0;

        // 对四个方向进行DFS，找到最长路径<br />
        if (j &gt; 0 &amp;&amp; matrix[i][j-1] &lt; matrix[i][j]) {<br />
            int left = longestPath(matrix, states, i, j-1, m, n);<br />
            maxd = max(maxd, left);<br />
        }<br />
        if (j &lt; n-1 &amp;&amp; matrix[i][j+1] &lt; matrix[i][j]) {<br />
            int right = longestPath(matrix, states, i, j+1, m, n);<br />
            maxd = max(maxd, right);<br />
        }<br />
        if (i &gt; 0 &amp;&amp; matrix[i-1][j] &lt; matrix[i][j]) {<br />
            int up = longestPath(matrix, states, i-1, j, m, n);<br />
            maxd = max(maxd, up);<br />
        }<br />
        if (i &lt; m-1 &amp;&amp; matrix[i+1][j] &lt; matrix[i][j]) {<br />
            int down = longestPath(matrix, states, i+1, j, m, n);<br />
            maxd = max(maxd, down);<br />
        }

        states[i][j] = maxd + 1;<br />
        return states[i][j];<br />
    }<br />
    int longestIncreasingPath(vector&lt;vector&lt;int&gt;&gt;&amp; matrix) {<br />
        int m = matrix.size();<br />
        if (m == 0) return 0;<br />
        int n = matrix[0].size();

        int result = 0;<br />
        vector&lt;vector&lt;int&gt;&gt; states(m, vector&lt;int&gt;(n, 0));<br />
        for (int i = 0; i &lt; m; ++i) {<br />
            for (int j = 0; j &lt; n; ++j) {<br />
                result = max(result, longestPath(matrix, states, i, j, m, n));<br />
            }<br />
        }

        return result;<br />
    }

    /**<br />
     *  方法和上面类似，不过利用dirs+循环可以使函数简化<br />
     */<br />
    vector&lt;vector&lt;int&gt;&gt; dirs = {{1, 0}, {-1, 0}, {0, 1}, {0, -1}};<br />
    int helper(vector&lt;vector&lt;int&gt;&gt;&amp; matrix, vector&lt;vector&lt;int&gt;&gt;&amp; visit, int i, int j, int m, int n) {<br />
        if (visit[i][j] &gt; 1) return visit[i][j];<br />
        int result = 1;<br />
        for (auto dir : dirs) {<br />
            int x = i + dir[0], y = j + dir[1];<br />
            if (x &lt; 0 || x &gt;= m || y &lt; 0 || y &gt;= n || matrix[i][j] &gt; matrix[x][y])<br />
                continue;<br />
            result = max(result, helper(matrix, visit, i, j, m, n));<br />
        }<br />
        visit[i][j] = result;<br />
        return result;<br />
    }<br />
    int longestIncreasingPath2(vector&lt;vector&lt;int&gt;&gt;&amp; matrix) {<br />
        int m = matrix.size();<br />
        if (m == 0) return 0;<br />
        int n = matrix[0].size();

        int result = 0;<br />
        vector&lt;vector&lt;int&gt;&gt; visit(m, vector&lt;int&gt;(n, 0));<br />
        for (int i = 0; i &lt; m; ++i) {<br />
            for (int j = 0; j &lt; n; ++j) {<br />
                result = max(result, helper(matrix, visit, i, j, m, n));<br />
            }<br />
        }

        return result;<br />
    }

    /**<br />
     *  BFS（拓扑排序）<br />
     *  这里的最长体现于，从数组中找出所有相对最小值（四个方向）<br />
     *  并且以每个相对最小值进行发散，看每个相对最小值能够到达的相对最大值，最远能到多远<br />
     *  路径长度其实就是计算队列的层数，看下一层的队列，如果下一层队列还有值，说明还可以前进，层数自然也会相加<br />
     *  这就像计算树的高度，只有还有下一层，高度就会增加<br />
     *<br />
     *  @param matrix &lt;#matrix description#&gt;<br />
     *<br />
     *  @return &lt;#return value description#&gt;<br />
     */<br />
    int longestIncreasingPath3(vector&lt;vector&lt;int&gt;&gt;&amp; matrix) {<br />
        const int m = matrix.size();<br />
        if (m == 0) return 0;<br />
        const int n = matrix[0].size();<br />
        if (n == 0) return 0;

        // 队列存储四个方向上都小于的数，visit则记录当前点有多少个大于自己的数<br />
        vector&lt;vector&lt;int&gt;&gt; visit(m, vector&lt;int&gt;(n, 0));<br />
        queue&lt;pair&lt;int, int&gt;&gt; queue, nqueue;<br />
        for (int i = 0; i &lt; m; i++) {<br />
            for (int j = 0; j &lt; n; j++) {<br />
                int result = 0;<br />
                int cur = matrix[i][j];<br />
                // left<br />
                if (j-1 &gt;= 0) result += cur &gt; matrix[i][j-1];<br />
                // right<br />
                if (j+1 &lt; n) result += cur &gt; matrix[i][j+1];<br />
                // up<br />
                if (i-1 &gt;= 0) result += cur &gt; matrix[i-1][j];<br />
                // down<br />
                if (i+1 &lt; m) result += cur &gt; matrix[i+1][j];

                visit[i][j] = result;<br />
                // 为0表示4个方向上都是递增，就是当前点比4个方向上的值都要小<br />
                if (result == 0)<br />
                    queue.emplace(i, j);<br />
            }<br />
        }

        // 判断四个方向上是否存在比队列（当前访问）中的值要大的数，有则加进队列nqueue(下一层访问)<br />
        // 等待访问完当前队列，交换队列；<br />
        // 对于在四个方向上的值，当其只存在一个比它小的值，也就是当前值，则加进来，这样保证最长长度<br />
        int l = 0;<br />
        while (!queue.empty()) {<br />
            while (!queue.empty()) {<br />
                pair&lt;int, int&gt; curPos = queue.front();<br />
                queue.pop();

                int i = curPos.first;<br />
                int j = curPos.second;

                int cur = matrix[i][j];

#define WALK(i, j)\<br />
    int &amp;result = visit[i][j];\<br />
    if (matrix[i][j] &gt; cur and result &gt; 0) {\<br />
        --result;\<br />
        if (result == 0) {\<br />
            nqueue.emplace(i, j);\<br />
        }\<br />
    }<br />
                if (j-1 &gt;= 0) {WALK(i,j-1)};<br />
                if (j+1 &lt;  n) {WALK(i,j+1)};<br />
                if (i-1 &gt;= 0) {WALK(i-1,j)};<br />
                if (i+1 &lt;  m) {WALK(i+1,j)};<br />
#undef WALK<br />
            }<br />
            ++l;<br />
            swap(queue, nqueue);<br />
        }

        return l;<br />
    }

    bool test() {<br />
        vector&lt;vector&lt;int&gt;&gt; nums = {<br />
            {9,9,4},<br />
            {6,6,8},<br />
            {2,1,1}<br />
        };

        int result = longestIncreasingPath3(nums);<br />
        cout &lt;&lt; result &lt;&lt; endl;

        return true;<br />
    }<br />
};

</code></pre>
<h2>130. Surrounded Regions</h2>
<h3>题意</h3>
<p>将围住的元素置为相同，没围住的不管</p>
<h3>思路</h3>
<ul><li>并查集，判断图连通</li>
<li>BFS</li>
<li>DFS</li></ul>
<h3>实现</h3>
<pre class="prettyprint linenums"><code>// 并查集实现<br />
class UF {<br />
private:<br />
    vector&lt;int&gt; id; // parent of i<br />
    vector&lt;int&gt; rank; // rank of subtree rooted at i<br />
    int count; // number of components

public:<br />
    // construct<br />
    UF(int N) {<br />
        count = N;<br />
        id.assign(N, 0);<br />
        rank.assign(N, 0);<br />
        for (int i = 0; i &lt; N; i++) {<br />
            id[i] = i;<br />
        }<br />
    }

    // free memory<br />
    ~UF() {<br />
        vector&lt;int&gt; temp;<br />
        id.swap(temp);<br />
        rank.swap(temp);<br />
    }

    // path compression<br />
    int find(int p) {<br />
        while (p != id[p]) {<br />
            id[p] = id[id[p]];<br />
            p = id[p];<br />
        }<br />
        return p;<br />
    }

    int getCount() {<br />
        return count;<br />
    }

    bool connected(int p, int q) {<br />
        return find(p) == find(q);<br />
    }

    void connect(int p, int q) {<br />
        int i = find(p);<br />
        int j = find(q);

        if (i == j) return ;<br />
        if (rank[i] &lt; rank[j]) id[i] = j;<br />
        else if (rank[i] &gt; rank[j]) id[j] = i;<br />
        else {<br />
            id[j] = i;<br />
            rank[i]++;<br />
        }<br />
        count--;<br />
    }<br />
};

void solve3(vector&lt;vector&lt;char&gt;&gt;&amp; board) {<br />
    int m = board.size();<br />
    if(m == 0) return ;<br />
    int n = board[0].size();<br />
    // 函数局部对象，函数返回时销毁对象<br />
    UF uf = UF(n * m + 1);

    for (int i = 0; i &lt; m; i++) {<br />
        for (int j = 0; j &lt; n; j++) {<br />
            // connect to the dummy node<br />
            if (i == 0 || i == m-1 || j == 0 || j == n-1)<br />
                uf.connect(i * n + j, n * m);<br />
            else if (board[i][j] == 'O') {<br />
                if (board[i-1][j] == 'O')<br />
                    uf.connect(i * n + j, (i-1) * n + j);<br />
                if (board[i+1][j] == 'O')<br />
                    uf.connect(i * n + j, (i+1) * n + j);<br />
                if (board[i][j-1] == 'O')<br />
                    uf.connect(i * n + j, i * n + j - 1);<br />
                if (board[i][j+1] == 'O')<br />
                    uf.connect(i * n + j, i * n + j + 1);<br />
            }<br />
        }<br />
    }

    for (int i = 0; i &lt; m; i++) {<br />
        for (int j = 0; j &lt; n; j++) {<br />
            if (!uf.connected(i * n + j, n * m))<br />
                board[i][j] = 'X';<br />
        }<br />
    }

}

</code></pre>
<p>需要另外学习并查集。</p>
<h2>279. Perfect Squares</h2>
<h3>题意</h3>
<p>由平方值组成的和的最小数组。</p>
<h3>思路</h3>
<ul><li>DP</li>
<li>静态DP</li>
<li>数学法（拉格朗日四方定理）</li>
<li>BFS</li></ul>
<h3>实现</h3>
<pre class="prettyprint linenums"><code>class Solution {<br />
public:<br />
    /**<br />
     *  将队列的值数值和平方数组进行一次类似二次循环<br />
     *  找出其和等于结果的level，level每进行一次二次循环则增加1<br />
     *  每次二次循环后队列的值都会全部更新到当前level的数值<br />
     *  比如<br />
     *  level = 1 的数值有 1，4，9<br />
     *  level = 2 的数值有 2, 5, 8, 10, 13, 18<br />
     *  ......<br />
     *  (计算方法是自己相加或者和别人相加)<br />
     *  level的数值其实是根据更新队列的次数<br />
     *  队列的数值会更新，但是平方数组则不会更新<br />
     *<br />
     *  @param n &lt;#n description#&gt;<br />
     *<br />
     *  @return &lt;#return value description#&gt;<br />
     */<br />
    int numSquares(int n) {<br />
        if (n &lt;= 0)<br />
            return 0;

        vector&lt;int&gt; squareNums;<br />
        vector&lt;int&gt; dp;<br />
        dp.assign(n, 0);

        for (int i = 1; i * i &lt;= n; i++) {<br />
            squareNums.push_back(i*i);<br />
            dp[i*i-1] = 1;<br />
        }

        if (squareNums.back() == n)<br />
            return 1;

        // 队列加入平方值<br />
        queue&lt;int&gt; searchQ;<br />
        for (int i = 0; i &lt; squareNums.size(); i++) {<br />
            searchQ.push(squareNums[i]);<br />
        }

        int level = 1;<br />
        while (!searchQ.empty()) {<br />
            level ++;<br />
            // 现保存其的size，因为队列会发生变化<br />
            int searchSize = searchQ.size();<br />
            for (int i = 0; i &lt; searchSize; i++) {<br />
                int cur = searchQ.front();

                for (int j = 0; j &lt; squareNums.size(); j++) {

                    int temp = squareNums[j];

                    if (temp + cur == n) {<br />
                        return level;<br />
                    }<br />
                    else if (temp + cur &lt; n &amp;&amp; dp[temp + cur - 1] == 0){  //大于1表明不是第一次访问该结点<br />
                        dp[cur + temp - 1]  = level;<br />
                        searchQ.push(temp + cur);<br />
                    }<br />
                    else if (temp + cur &gt; n) {<br />
                        break;<br />
                    }<br />
                }

                searchQ.pop();<br />
            }<br />
        }<br />
        return 0;<br />
    }

    /**<br />
     *  DP<br />
     *<br />
     *  @param n &lt;#n description#&gt;<br />
     *<br />
     *  @return &lt;#return value description#&gt;<br />
     */<br />
    int numSquares2(int n) {<br />
        if (n &lt;= 0)<br />
            return 0;<br />
        vector&lt;int&gt; dp(n + 1, INT_MAX);<br />
        dp[0] = 0;

        for (int i = 1; i &lt;= n; i++)<br />
            for (int j = 1; j * j &lt;= i; j++)<br />
                dp[i] = min(dp[i], dp[i - j * j] + 1);

        return dp[n];<br />
    }

    /**<br />
     *  静态动态规划<br />
     *<br />
     *  @param n &lt;#n description#&gt;<br />
     *<br />
     *  @return &lt;#return value description#&gt;<br />
     */<br />
    int numSquares3(int n) {<br />
        if (n &lt;= 0)<br />
            return 0;<br />
        static vector&lt;int&gt; dp({0});

        while (dp.size() &lt;= n) {<br />
            int msize = dp.size();<br />
            int curNum = INT_MAX;<br />
            for (int i = 0; i * i &lt;= msize; i++) {<br />
                curNum = min(curNum, dp[msize - i*i]);<br />
            }<br />
            dp.push_back(curNum);<br />
        }<br />
        return dp[n];<br />
    }

    /**<br />
     *  数学法<br />
     *  拉格朗日四方定理<br />
     *<br />
     *  @param n &lt;#n description#&gt;<br />
     *<br />
     *  @return &lt;#return value description#&gt;<br />
     */<br />
    int is_squre(int n) {<br />
        int sqrt_n = (int)sqrt(n);<br />
        return sqrt_n * sqrt_n == n;<br />
    }<br />
    int numSquares4(int n) {<br />
        if (n &lt;= 0)<br />
            return 0;

        // n % 4 = 0<br />
        while ((n &amp; 3) == 0) {<br />
            n &gt;&gt;= 2;

        }<br />
        // n % 8 = 7<br />
        if ((n &amp; 7) == 7) {<br />
            return 4;<br />
        }

        // 检查2是否是结果<br />
        int sqrt_n = (int)(sqrt(n));<br />
        for (int i = 1; i &lt;= sqrt_n; i++) {<br />
            if (is_squre(n - i * i)) {<br />
                return 2;<br />
            }<br />
        }

        return 3;<br />
    }

    bool test() {<br />
        int n = 11;<br />
        int result = numSquares2(n);<br />
        cout &lt;&lt; result &lt;&lt; endl;

        return true;<br />
    }<br />
};

</code></pre>
<p>需要另外学习静态DP，数学法。</p>
<h2>310. Minimum Height Trees</h2>
<h3>题目</h3>
<p><a href="https://leetcode.com/problems/minimum-height-trees/?tab=Description" rel="external nofollow noreferrer">题目</a></p>
<p>从n个结点n-1条边（也就是树）中选出一个结点作为根结点，到图的其他结点路径最短（高度小）</p>
<h3>思路</h3>
<ol><li>取图的最长路径（从0开始）的中间结点。</li>
<li>不停的删除入度为1的结点（也就是叶结点），直到不能再删，（剩下1到2个结点），取出一个即可。</li></ol>
<ul><li>DFS</li>
<li>BFS（借助拓扑排序的思想）</li></ul>
<pre class="prettyprint linenums"><code>struct TreeNode {<br />
    set&lt;int&gt; list;  // 方便删除邻居<br />
    TreeNode() {};<br />
    // 如果<br />
    bool isLeaf(){<br />
        return list.size() == 1;<br />
    };<br />
};<br />
class Solution {<br />
public:<br />
    vector&lt;int&gt; findMinHeightTrees(int n, vector&lt;pair&lt;int, int&gt;&gt;&amp; edges) {<br />
        if (n == 1) return {0}; // 当n为1的时候，初始化node1为空，结果为空（因为从0开始）

        // 用树结点存储这棵树，耗费空间为o(n+2e)<br />
        vector&lt;TreeNode&gt; tree(n);<br />
        for (auto edge : edges) {<br />
            tree[edge.first].list.insert(edge.second);<br />
            tree[edge.second].list.insert(edge.first);<br />
        }

        vector&lt;int&gt; curNode(0);<br />
        vector&lt;int&gt; newNode(0);

        // 记录叶子结点<br />
        for (int i = 0; i &lt; tree.size(); i++) {<br />
            if (tree[i].isLeaf())<br />
                curNode.push_back(i);<br />
        }

        while (1) {<br />
            //  遍历邻居删除<br />
            for (auto leaf : curNode) {<br />
                for (set&lt;int&gt;::iterator iter = tree[leaf].list.begin(); iter != tree[leaf].list.end(); iter++) {<br />
                    int neighbor = *iter;<br />
                    tree[neighbor].list.erase(leaf);

                    // 删除结点后，如果还是叶子结点，则放到newNode中<br />
                    if (tree[neighbor].isLeaf())<br />
                        newNode.push_back(neighbor);

                }<br />
            }<br />
            // 如果newNode为空，表明之前的curNode不是叶子结点，要么是剩下一个结点，要么是剩下两个相互连接的结点<br />
            if (newNode.empty())<br />
                break;<br />
            curNode.clear();<br />
            swap(curNode, newNode);<br />
        }<br />
        // curNode只剩下一个结点，因为邻居为空，所以不能压入newNode中<br />
        if (curNode.size() != 0)<br />
            return curNode;<br />
        // curNode有两个相互连接的结点，邻居都为1，所以压入newNode中<br />
        else if (curNode.size() == 0)<br />
            return newNode;

        return {};<br />
    }

    /**<br />
     *  和上面思想相同<br />
     *<br />
     *  @param n               &lt;#n description#&gt;<br />
     *  @param vector&lt;pair&lt;int &lt;#vector&lt;pair&lt;int description#&gt;<br />
     *  @param edges           &lt;#edges description#&gt;<br />
     *<br />
     *  @return &lt;#return value description#&gt;<br />
     */<br />
    vector&lt;int&gt; findMinHeightTrees2(int n, vector&lt;pair&lt;int, int&gt;&gt;&amp; edges) {<br />
        if (n == 1)<br />
            return {0};

        vector&lt;int&gt; result, degrees(n, 0);<br />
        vector&lt;vector&lt;int&gt;&gt; graph(n, vector&lt;int&gt;());<br />
        queue&lt;int&gt; queue;

        // 统计结点信息，保存到graph中<br />
        for (auto edge : edges) {<br />
            graph[edge.first].push_back(edge.second);<br />
            graph[edge.second].push_back(edge.first);

            degrees[edge.first]++;<br />
            degrees[edge.second]++;<br />
        }

        // 统计入度数为1的结点，也就是叶结点<br />
        for (int i = 0; i &lt; degrees.size(); ++i) {<br />
            if (degrees[i] == 1) {<br />
                queue.push(i);<br />
            }<br />
        }

        // 删除结点，直到剩下1到2个结点，就是题目要求的最小高度的树的跟结点<br />
        while (n &gt; 2) {<br />
            int qsize = queue.size();

            for (int i = 0; i &lt; qsize; i++) {<br />
                int temp = queue.front();<br />
                queue.pop();<br />
                --n;

                for (vector&lt;int&gt;::iterator iter = graph[temp].begin(); iter != graph[temp].end(); ++iter) {<br />
                    --degrees[*iter];

                    if (degrees[*iter] == 1)<br />
                        queue.push(*iter);<br />
                }<br />
            }<br />
        }

        while (!queue.empty()) {<br />
            result.push_back(queue.front());<br />
            queue.pop();<br />
        }

        return result;<br />
    }

    /**<br />
     *  DFS<br />
     *  思路在于，因为题目要求的是，从哪个结点开始，也就是作为跟结点，到所有其他结点的路径长度最短；<br />
     *  所以跟结点在于最长路径的中间结点上；<br />
     */<br />
    int max_len;<br />
    int v;<br />
    void DFS(vector&lt;vector&lt;int&gt;&gt;&amp; graph, vector&lt;bool&gt;&amp; visited, vector&lt;int&gt;&amp; path, int cur, int count) {<br />
        // 将当前结点设为访问过，并且添加进路径中<br />
        visited[cur] = true;<br />
        count++;<br />
        path.push_back(cur);

        // 访问当前结点的所有邻居结点<br />
        for (auto it = graph[cur].begin(); it != graph[cur].end(); it++) {<br />
            if (!visited[*it])<br />
                DFS(graph, visited, path, *it, count);<br />
        }

        if (count &gt; max_len) {<br />
            max_len = count;<br />
            v = cur;<br />
        }<br />
        visited[cur] = false;<br />
    }<br />
    vector&lt;int&gt; findMinHeightTrees3(int n, vector&lt;pair&lt;int, int&gt;&gt;&amp; edges) {<br />
        vector&lt;vector&lt;int&gt;&gt; graph(n);<br />
        // 添加邻居结点<br />
        for (int i = 0; i &lt; edges.size(); i++) {<br />
            graph[edges[i].first].push_back(edges[i].second);<br />
            graph[edges[i].second].push_back(edges[i].first);<br />
        }

        vector&lt;bool&gt; visited(n, false);<br />
        vector&lt;int&gt; path;

        // 计算最远路径，以及路径最后一个结点v<br />
        DFS(graph, visited, path, 0, 0);

        max_len = 0;<br />
        path.clear();

        // 从叶结点v开始，计算最长<br />
        DFS(graph, visited, path, v, 0);

        vector&lt;int&gt; result;<br />
        // 如果最长路径为偶数，取中间两个数，否则只取一个数<br />
        if (max_len % 2 == 0) {<br />
            result.push_back(path[max_len/2]);<br />
            result.push_back(path[max_len/2 - 1]);<br />
        }<br />
        else {<br />
            result.push_back(path[max_len/2]);<br />
        }

        return result;<br />
    }

    bool test() {<br />
        int n = 3;<br />
        vector&lt;pair&lt;int, int&gt;&gt; nodes = {<br />
            {1, 0},<br />
            {1, 2},<br />
        };

        vector&lt;int&gt; result = findMinHeightTrees3(n, nodes);

        cout &lt;&lt; result[0] &lt;&lt; endl;

        return true;<br />
    }<br />
};

</code></pre>
<h2>199. Binary Tree Right Side View</h2>
<h3>题意</h3>
<p>从右边看二叉树的结点的数组</p>
<h3>思想</h3>
<ul><li>DFS：递归函数里纪录level变量，当level大于结果数组size时，加入当前结点值，优先遍历右子树；</li>
<li>BFS：层次遍历，访问每层最右结点；</li>
<li>分治：用两个数组存储左右子树的结点，先取右边数组，大于右边数组则直取左边数组；</li></ul>
<p>注意：右子树没有的时候看到的是左子树。</p>
<h3>实现</h3>
<pre class="prettyprint linenums"><code>class Solution {<br />
public:<br />
    /**<br />
     *  递归<br />
     *<br />
     *  @param root   &lt;#root description#&gt;<br />
     *  @param level  &lt;#level description#&gt;<br />
     *  @param result &lt;#result description#&gt;<br />
     */<br />
    void DFS(TreeNode* root, int level, vector&lt;int&gt; &amp;result) {<br />
        if (root == NULL) return ;<br />
        // 如果当前层大于数组的值（存储每一层的最右值，代表已经访问到了第几层）<br />
        if (level &gt; result.size()) result.push_back(root-&gt;val);<br />
        // 优先访问右结点<br />
        DFS(root-&gt;right, level+1, result);<br />
        DFS(root-&gt;left, level+1, result);<br />
    }<br />
    vector&lt;int&gt; rightSideView(TreeNode* root) {<br />
        vector&lt;int&gt; result;<br />
        DFS(root, 1, result);<br />
        return result;<br />
    }

    /**<br />
     *  层次遍历<br />
     *  访问每一层的结点，取最右元素<br />
     *<br />
     *  @param root &lt;#root description#&gt;<br />
     *<br />
     *  @return &lt;#return value description#&gt;<br />
     */<br />
    vector&lt;int&gt; rightSideView2(TreeNode* root) {<br />
        vector&lt;int&gt; result;<br />
        if (root == NULL) return result;<br />
        queue&lt;TreeNode *&gt; queue;<br />
        queue.push(root);

        while (!queue.empty()) {<br />
            int count = (int)queue.size();<br />
            for (int i = 0; i &lt; count; i++) {<br />
                TreeNode * curr = queue.front();<br />
                queue.pop();<br />
                // 最右结点<br />
                if (i == count-1) {<br />
                    result.push_back(curr-&gt;val);<br />
                }<br />
                if (curr-&gt;left != NULL) {<br />
                    queue.push(curr-&gt;left);<br />
                }<br />
                if (curr-&gt;right != NULL) {<br />
                    queue.push(curr-&gt;right);<br />
                }<br />
            }<br />
        }<br />
        return result;<br />
    }

    /**<br />
     *  分治法<br />
     *<br />
     *  @param root &lt;#root description#&gt;<br />
     *<br />
     *  @return &lt;#return value description#&gt;<br />
     */<br />
    vector&lt;int&gt; rightSideView3(TreeNode* root) {<br />
        if (root == NULL) {<br />
            return vector&lt;int&gt;();<br />
        }

        //两个数组分别存储左右两颗子树的的结点<br />
        vector&lt;int&gt; left = rightSideView3(root-&gt;left);<br />
        vector&lt;int&gt; right = rightSideView3(root-&gt;right);;

        vector&lt;int&gt; result;<br />
        result.push_back(root-&gt;val);

        //取左边和右边数组长度大的，大于右边数组的则取左边数组<br />
        for (int i = 0; i &lt; max(left.size(), right.size()); ++i) {<br />
            if (i &gt;= right.size())<br />
                result.push_back(left.at(i));<br />
            else<br />
                result.push_back(right.at(i));<br />
        }<br />
        return result;<br />
    }

    bool test() {<br />
        TreeNode * root = new TreeNode(2);<br />
        TreeNode * left = new TreeNode(1);<br />
        TreeNode * right = new TreeNode(3);

        root-&gt;left = left;<br />
        root-&gt;right = right;

        vector&lt;int&gt; result = rightSideView3(root);<br />
        return true;<br />
    }<br />
};

</code></pre>
<h2>其他</h2>
<h3>匹配</h3>
<p>匹配分为正则表达式匹配和通配符区匹配;</p>
<p>前者pattern包含一些关键字，比如*的用法是紧跟在pattern的某个字符之后，表示这个字符可以出现任意多次（包括0次）；后者通配符匹配服，同样的符号可以代表匹配任意长度的任意字符组成的串。</p>
<h3>全排列</h3>
<ol><li>全排列就是第一个数字起每个数字分别与它后面的数字进行交换；</li>
<li>去重的全排列就是从第一个数字起每个数分别与它后面非重复出现的数字进行交换；</li>
<li>全排列的非递归实现就是由后往前找替代数和替代点，即由后往前找第一个比替换数大的数和替换数进行交换，最后颠倒替换点后的所有数据；</li></ol>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qwv70y8.html">MySQL中索引和优化的用法总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qw24jzq.html">asp&period;net 后台实现删除，划掉效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z17klv9.html">Android手机应用程序开发环境配置（Eclipse&plus;Java&plus;ADT）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjo7wd9.html">python用paramiko将执行的结果存入excel表格</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge3gll8.html">HTML与DOM BOM javascript</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzgdn08.html">MYSQL ORDER BY Optimization</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg3mdm8.html">VxWorks启动过程详解（下）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1k0l009.html">HTTP协议简介详解 HTTP协议发展 原理 请求方法 响应状态码 请求头 请求首部 java模拟浏览器客户端服务端</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jgpy5q.html">移动web开发中input等输入框问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvdjg28.html">Python IO模型</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy2xgdq.html">codeforces545C</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyr43jq.html">JVM&amp;&num;183&semi;垃圾收集器与内存分配策略之对象是否可被回收！</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4jggk9.html">Eclipse安装Git插件及简单操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2kneoq.html">使用 ES2015 编写 Gulp 构建</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r42j68.html">Cocos Creator cc&period;Node&period;点击事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyllln9.html">Visualforce控制器</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj4k2r9.html">Onezero团队第三次站立会议随感</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j15p7w9.html">Java-Runoob-高级教程-实例-方法：13&period; Java 实例 &ndash; for 和 foreach循环使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9606x0n9.html">文科妹学 GitHub 简易教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnn5jw2q.html">OAF 获取页面路径</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9jznr5e8.html">Linux系统迁移</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zm5j59.html">redis3 list类型</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mj0ej8.html">【转】 如何提高自己的acm个人能力</a>
			</li>
						<li><a href="https://www.batexi.com/a/93ydr1g8.html">iPhone应用中加入评分功能</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj5pgr8.html">&lbrack;转&rsqb;编写高性能的Lua代码</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpd1mjq.html">使用滚动条（ActionBar）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj5mgr8.html">新版本chrome浏览器控制台怎么设置成独立的窗口</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jznoml8.html">mysql 无法启动的原因Can&amp;&num;39&semi;t start server&colon; can&amp;&num;39&semi;t create PID file&colon; No space left on device</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1zloxq.html">CMD修改IP地址</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2jmo0v8.html">setTimeout小总结</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
